std::unique_ptr< _Tp[], _Dp > Class Template Reference
Utilities » Memory » Pointer Abstractions

`#include <memory>`

## Public Types

template<typename _Up >
using | __safe_conversion_raw = __and_< __or_< __or_< is_same< _Up, pointer >, is_same< _Up, nullptr_t > >, __and_< is_pointer< _Up >, is_same< pointer, element_type * >, is_convertible< typename remove_pointer< _Up >::type(*)[], element_type(*)[]> > > >
template<typename _Up , typename _Ep , typename _UPtr = unique_ptr<_Up, _Ep>, typename _UP_pointer = typename _UPtr::pointer, typename _UP_element_type = typename _UPtr::element_type>
using | __safe_conversion_up = __and_< is_array< _Up >, is_same< pointer, element_type * >, is_same< _UP_pointer, _UP_element_type * >, is_convertible< _UP_element_type(*)[], element_type(*)[]> >
using | deleter_type = _Dp
using | element_type = _Tp
using | pointer = typename __uniq_ptr_impl< _Tp, _Dp >::pointer

## Public Member Functions

template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>
constexpr | unique_ptr () noexcept
template<typename _Up , typename _Vp = _Dp, typename = _DeleterConstraint<_Vp>, typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>
constexpr | unique_ptr (_Up __p) noexcept
template<typename _Up , typename _Del = deleter_type, typename = _Require<__safe_conversion_raw<_Up>, is_move_constructible<_Del>>>
constexpr | unique_ptr (_Up __p, __enable_if_t<!is_lvalue_reference< _Del >::value, _Del && > __d) noexcept
template<typename _Up , typename _Del = deleter_type, typename = _Require<__safe_conversion_raw<_Up>, is_copy_constructible<_Del>>>
constexpr | unique_ptr (_Up __p, const deleter_type &__d) noexcept
template<typename _Up , typename _Del = deleter_type, typename _DelUnref = typename remove_reference<_Del>::type, typename = _Require<__safe_conversion_raw<_Up>>>
| unique_ptr (_Up, __enable_if_t< is_lvalue_reference< _Del >::value, _DelUnref && >)=delete
| unique_ptr (const unique_ptr &)=delete
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>
constexpr | unique_ptr (nullptr_t) noexcept
| unique_ptr (unique_ptr &&)=default
template<typename _Up , typename _Ep , typename = _Require< __safe_conversion_up<_Up, _Ep>, __conditional_t<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>>>
constexpr | unique_ptr (unique_ptr< _Up, _Ep > &&__u) noexcept
| ~unique_ptr ()
constexpr pointer | get () const noexcept
constexpr const deleter_type & | get_deleter () const noexcept
constexpr deleter_type & | get_deleter () noexcept
constexpr | operator bool () const noexcept
unique_ptr & | operator= (const unique_ptr &)=delete
constexpr unique_ptr & | operator= (nullptr_t) noexcept
unique_ptr & | operator= (unique_ptr &&)=default
template<typename _Up , typename _Ep >
constexpr enable_if< __and_< __safe_conversion_up< _Up, _Ep >, is_assignable< deleter_type &, _Ep && > >::value, unique_ptr & >::type | operator= (unique_ptr< _Up, _Ep > &&__u) noexcept
constexpr std::add_lvalue_reference< element_type >::type | operator[] (size_t __i) const
constexpr pointer | release () noexcept
template<typename _Up , typename = _Require< __or_<is_same<_Up, pointer>, __and_<is_same<pointer, element_type*>, is_pointer<_Up>, is_convertible< typename remove_pointer<_Up>::type(*)[], element_type(*)[] > > > >>
constexpr void | reset (_Up __p) noexcept
constexpr void | reset (nullptr_t=nullptr) noexcept
constexpr void | swap (unique_ptr &__u) noexcept

## Detailed Description

template<typename _Tp, typename _Dp>
class std::unique_ptr< _Tp[], _Dp >

A move-only smart pointer that manages unique ownership of an array.

Since
  C++11

Definition at line 537 of file unique_ptr.h.

## Member Typedef Documentation

## __safe_conversion_raw

template<typename _Tp , typename _Dp >
template<typename _Up >

using std::unique_ptr< _Tp[], _Dp >::__safe_conversion_raw = __and_< __or_<__or_<is_same<_Up, pointer>, is_same<_Up, nullptr_t> >, __and_<is_pointer<_Up>, is_same<pointer, element_type*>, is_convertible< typename remove_pointer<_Up>::type(*)[], element_type(*)[]> > > >

Definition at line 571 of file unique_ptr.h.

## __safe_conversion_up

template<typename _Tp , typename _Dp >
template<typename _Up , typename _Ep , typename _UPtr = unique_ptr<_Up, _Ep>, typename _UP_pointer = typename _UPtr::pointer, typename _UP_element_type = typename _UPtr::element_type>

using std::unique_ptr< _Tp[], _Dp >::__safe_conversion_up = __and_< is_array<_Up>, is_same<pointer, element_type*>, is_same<_UP_pointer, _UP_element_type*>, is_convertible<_UP_element_type(*)[], element_type(*)[]> >

Definition at line 562 of file unique_ptr.h.

## deleter_type

template<typename _Tp , typename _Dp >

using std::unique_ptr< _Tp[], _Dp >::deleter_type = _Dp

Definition at line 554 of file unique_ptr.h.

## element_type

template<typename _Tp , typename _Dp >

using std::unique_ptr< _Tp[], _Dp >::element_type = _Tp

Definition at line 553 of file unique_ptr.h.

## pointer

template<typename _Tp , typename _Dp >

using std::unique_ptr< _Tp[], _Dp >::pointer = typename __uniq_ptr_impl<_Tp, _Dp>::pointer

Definition at line 552 of file unique_ptr.h.

## Constructor & Destructor Documentation

## unique_ptr() [1/7]

template<typename _Tp , typename _Dp >
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>

constexpr std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( |  | ) |

inline constexpr noexcept

Default constructor, creates a unique_ptr that owns nothing.

Definition at line 587 of file unique_ptr.h.

## unique_ptr() [2/7]

template<typename _Tp , typename _Dp >
template<typename _Up , typename _Vp = _Dp, typename = _DeleterConstraint<_Vp>, typename = typename enable_if< __safe_conversion_raw<_Up>::value, bool>::type>

constexpr std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | _Up | __p | ) |

inline explicit constexpr noexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an array of a type safely convertible to an array of `element_type`

The deleter will be value-initialized.

Definition at line 605 of file unique_ptr.h.

## unique_ptr() [3/7]

template<typename _Tp , typename _Dp >
template<typename _Up , typename _Del = deleter_type, typename = _Require<__safe_conversion_raw<_Up>, is_copy_constructible<_Del>>>

constexpr std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | _Up | __p,
|  | const deleter_type & | __d
| ) |  |

inline constexpr noexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an array of a type safely convertible to an array of `element_type`
  __d | A reference to a deleter.

The deleter will be initialized with `__d`

Definition at line 621 of file unique_ptr.h.

## unique_ptr() [4/7]

template<typename _Tp , typename _Dp >
template<typename _Up , typename _Del = deleter_type, typename = _Require<__safe_conversion_raw<_Up>, is_move_constructible<_Del>>>

constexpr std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | _Up | __p,
|  | __enable_if_t<!is_lvalue_reference< _Del >::value, _Del && > | __d
| ) |  |

inline constexpr noexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an array of a type safely convertible to an array of `element_type`
  __d | A reference to a deleter.

The deleter will be initialized with `std::move(__d)`

Definition at line 636 of file unique_ptr.h.

## unique_ptr() [5/7]

template<typename _Tp , typename _Dp >

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | unique_ptr< _Tp[], _Dp > && |  | ) |

default

Move constructor.

## unique_ptr() [6/7]

template<typename _Tp , typename _Dp >
template<typename _Del = _Dp, typename = _DeleterConstraint<_Del>>

constexpr std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | nullptr_t |  | ) |

inline constexpr noexcept

Creates a unique_ptr that owns nothing.

Definition at line 654 of file unique_ptr.h.

## unique_ptr() [7/7]

template<typename _Tp , typename _Dp >
template<typename _Up , typename _Ep , typename = _Require< __safe_conversion_up<_Up, _Ep>, __conditional_t<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>>>

constexpr std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | unique_ptr< _Up, _Ep > && | __u | ) |

inline constexpr noexcept

Definition at line 664 of file unique_ptr.h.

## ~unique_ptr()

template<typename _Tp , typename _Dp >

std::unique_ptr< _Tp[], _Dp >::~unique_ptr | ( |  | ) |

inline

Destructor, invokes the deleter if the stored pointer is not null.

Definition at line 672 of file unique_ptr.h.

## Member Function Documentation

## get()

template<typename _Tp , typename _Dp >

constexpr pointer std::unique_ptr< _Tp[], _Dp >::get | ( |  | ) | const

inline constexpr noexcept

Return the stored pointer.

Definition at line 733 of file unique_ptr.h.

## get_deleter() [1/2]

template<typename _Tp , typename _Dp >

constexpr const deleter_type & std::unique_ptr< _Tp[], _Dp >::get_deleter | ( |  | ) | const

inline constexpr noexcept

Return a reference to the stored deleter.

Definition at line 745 of file unique_ptr.h.

## get_deleter() [2/2]

template<typename _Tp , typename _Dp >

constexpr deleter_type & std::unique_ptr< _Tp[], _Dp >::get_deleter | ( |  | ) |

inline constexpr noexcept

Return a reference to the stored deleter.

Definition at line 739 of file unique_ptr.h.

## operator bool()

template<typename _Tp , typename _Dp >

constexpr std::unique_ptr< _Tp[], _Dp >::operator bool | ( |  | ) | const

inline explicit constexpr noexcept

Return `true` if the stored pointer is not null.

Definition at line 750 of file unique_ptr.h.

## operator=() [1/3]

template<typename _Tp , typename _Dp >

constexpr unique_ptr & std::unique_ptr< _Tp[], _Dp >::operator= | ( | nullptr_t |  | ) |

inline constexpr noexcept

Reset the unique_ptr to empty, invoking the deleter if necessary.

Definition at line 713 of file unique_ptr.h.

## operator=() [2/3]

template<typename _Tp , typename _Dp >

unique_ptr & std::unique_ptr< _Tp[], _Dp >::operator= | ( | unique_ptr< _Tp[], _Dp > && |  | ) |

default

Move assignment operator.

Invokes the deleter if this object owns a pointer.

## operator=() [3/3]

template<typename _Tp , typename _Dp >
template<typename _Up , typename _Ep >

constexpr enable_if< __and_< __safe_conversion_up< _Up, _Ep >, is_assignable< deleter_type &, _Ep && > >::value, unique_ptr & >::type std::unique_ptr< _Tp[], _Dp >::operator= | ( | unique_ptr< _Up, _Ep > && | __u | ) |

inline constexpr noexcept

Assignment from another type.

Parameters

  __u | The object to transfer ownership from, which owns a convertible pointer to an array object.

Invokes the deleter if this object owns a pointer.

Definition at line 703 of file unique_ptr.h.

## operator[]()

template<typename _Tp , typename _Dp >

constexpr std::add_lvalue_reference< element_type >::type std::unique_ptr< _Tp[], _Dp >::operator[] | ( | size_t | __i | ) | const

inline constexpr

Access an element of owned array.

Definition at line 724 of file unique_ptr.h.

## release()

template<typename _Tp , typename _Dp >

constexpr pointer std::unique_ptr< _Tp[], _Dp >::release | ( |  | ) |

inline constexpr noexcept

Release ownership of any stored pointer.

Definition at line 758 of file unique_ptr.h.

## reset() [1/2]

template<typename _Tp , typename _Dp >
template<typename _Up , typename = _Require< __or_<is_same<_Up, pointer>, __and_<is_same<pointer, element_type*>, is_pointer<_Up>, is_convertible< typename remove_pointer<_Up>::type(*)[], element_type(*)[] > > > >>

constexpr void std::unique_ptr< _Tp[], _Dp >::reset | ( | _Up | __p | ) |

inline constexpr noexcept

Replace the stored pointer.

Parameters

  __p | The new pointer to store.

The deleter will be invoked if a pointer is already owned.

Definition at line 781 of file unique_ptr.h.

References std::move().

## reset() [2/2]

template<typename _Tp , typename _Dp >

constexpr void std::unique_ptr< _Tp[], _Dp >::reset | ( | nullptr_t | = `nullptr` | ) |

inline constexpr noexcept

Definition at line 785 of file unique_ptr.h.

## swap()

template<typename _Tp , typename _Dp >

constexpr void std::unique_ptr< _Tp[], _Dp >::swap | ( | unique_ptr< _Tp[], _Dp > & | __u | ) |

inline constexpr noexcept

Exchange the pointer and deleter with another object.

Definition at line 791 of file unique_ptr.h.

The documentation for this class was generated from the following file:

- unique_ptr.h